Debian Bug report logs - #430367
Integrate support of a newer dpkg-shlibdeps working at the symbol level

version graph

Package: dpkg-dev; Maintainer for dpkg-dev is Dpkg Developers <debian-dpkg@lists.debian.org>; Source for dpkg-dev is src:dpkg.

Reported by: Raphael Hertzog <hertzog@debian.org>

Date: Sat, 23 Jun 2007 20:21:01 UTC

Severity: normal

Found in version dpkg/1.14.4

Fixed in version 1.14.7~newshlib

Done: Raphael Hertzog <hertzog@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <team@dpkg.org>:
Bug#430367; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
New Bug report received and forwarded. Copy sent to Dpkg Developers <team@dpkg.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: submit@bugs.debian.org
Subject: Integrate support of a newer dpkg-shlibdeps working at the symbol level
Date: Sat, 23 Jun 2007 21:17:24 +0100
[Message part 1 (text/plain, inline)]
Package: dpkg
Version: 1.14.4

Please find attached a patch integrating my work on dpkg-shlibdeps in the
current dpkg version. I've put my work in a git repository on
git://git.debian.org/git/private/hertzog/dpkg (branch dpkg-shlibdeps)

It creates a set of modules in /usr/lib/dpkg/Dpkg/ as I need some shared
code between dpkg-gensymbols and dpkg-shlibdeps.

There's no documentation update yet, but I shall work on that once the
code is integrated. I'll maintain that code over time and do any possible
bugfixes and enhancements that may appear.

I expect at least some enhancements in the way we handle the symbols files
over the set of architectures (ie to share some information instead of
having simply debian/package.symbols.arch).

Any comments welcome. Please note that the code in the bzr branch is
outdated now. I did substantial changes to put some code in modules.

For reference, the following wiki page contains the initial spec that lead
me in this work:
http://wiki.debian.org/Projects/ImprovedDpkgShlibdeps

Cheers,
-- 
Raphaël Hertzog

Premier livre français sur Debian GNU/Linux :
http://www.ouaza.com/livre/admin-debian/
[dpkg.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <team@dpkg.org>:
Bug#430367; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Frank Lichtenheld <djpig@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <team@dpkg.org>. Full text and rfc822 format available.

Message #10 received at 430367@bugs.debian.org (full text, mbox):

From: Frank Lichtenheld <djpig@debian.org>
To: Raphael Hertzog <hertzog@debian.org>, 430367@bugs.debian.org
Subject: Re: Bug#430367: Integrate support of a newer dpkg-shlibdeps working at the symbol level
Date: Sun, 1 Jul 2007 12:45:56 +0200
On Sat, Jun 23, 2007 at 09:17:24PM +0100, Raphael Hertzog wrote:
> It creates a set of modules in /usr/lib/dpkg/Dpkg/ as I need some shared
> code between dpkg-gensymbols and dpkg-shlibdeps.
> 
> There's no documentation update yet, but I shall work on that once the
> code is integrated. I'll maintain that code over time and do any possible
> bugfixes and enhancements that may appear.
> 
> I expect at least some enhancements in the way we handle the symbols files
> over the set of architectures (ie to share some information instead of
> having simply debian/package.symbols.arch).

Ok. I would be willing to start integrating this into dpkg. I don't like
the overall quality of the code, though. It might not be bad compared to
the code that can currently be found in dpkg-dev, but it doesn't really
measure up to any objective standards (e.g. there are too many open
calls that use the older, much more insecure and somwhat slower syntax).

My proposed plan would be to:

1) Apply the part of the patch that adds the modules. Since that doesn't
   add anything useful to dpkg in its own right, we should probably make
   this in a branch
2) Do some code clean-up
3) Add a minimal test suite (no excuse not to do this for entirely new code!)
   Something simple with Test::More should suffice, but if someone
   prefers a more sophisticated framework, I will not stand in his way.
4) when satisfied with the result, apply the rest of the patch
5) Merge to trunk/

I would give Raphael commit rights to the repository with the
understanding that he limits himself to the branch integrating his work
for now (I really see no need for technical measures enforcing that, we
are all grown-ups, right?)

Objections? Comments?

Gruesse,
-- 
Frank Lichtenheld <djpig@debian.org>
www: http://www.djpig.de/



Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <team@dpkg.org>:
Bug#430367; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Frank Lichtenheld <djpig@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <team@dpkg.org>. Full text and rfc822 format available.

Message #15 received at 430367@bugs.debian.org (full text, mbox):

From: Frank Lichtenheld <djpig@debian.org>
To: Raphael Hertzog <hertzog@debian.org>, 430367@bugs.debian.org
Subject: Re: Bug#430367: Integrate support of a newer dpkg-shlibdeps working at the symbol level
Date: Sun, 1 Jul 2007 16:02:58 +0200
On Sun, Jul 01, 2007 at 12:45:56PM +0200, Frank Lichtenheld wrote:
> 1) Apply the part of the patch that adds the modules. Since that doesn't
>    add anything useful to dpkg in its own right, we should probably make
>    this in a branch
> 2) Do some code clean-up
> 3) Add a minimal test suite (no excuse not to do this for entirely new code!)
>    Something simple with Test::More should suffice, but if someone
>    prefers a more sophisticated framework, I will not stand in his way.
> 4) when satisfied with the result, apply the rest of the patch
> 5) Merge to trunk/

On second thought: as we don't apply the patch in trunk/, I will apply
it completly and not in separate steps

Gruesse,
-- 
Frank Lichtenheld <djpig@debian.org>
www: http://www.djpig.de/



Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <team@dpkg.org>:
Bug#430367; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <team@dpkg.org>. Full text and rfc822 format available.

Message #20 received at 430367@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: Frank Lichtenheld <djpig@debian.org>
Cc: 430367@bugs.debian.org
Subject: Re: Bug#430367: Integrate support of a newer dpkg-shlibdeps working at the symbol level
Date: Sun, 1 Jul 2007 16:36:01 +0200
[Message part 1 (text/plain, inline)]
On Sun, 01 Jul 2007, Frank Lichtenheld wrote:
> On Sun, Jul 01, 2007 at 12:45:56PM +0200, Frank Lichtenheld wrote:
> > 1) Apply the part of the patch that adds the modules. Since that doesn't
> >    add anything useful to dpkg in its own right, we should probably make
> >    this in a branch
> > 2) Do some code clean-up

I'll gladly do the code cleanup if you can elaborate on what's not okay
according to your (perl coding) standards. 

In general, I might even be interested in doing this for more of the perl
code contained in dpkg (though I don't want to promise anything).

> > 3) Add a minimal test suite (no excuse not to do this for entirely new code!)
> >    Something simple with Test::More should suffice, but if someone
> >    prefers a more sophisticated framework, I will not stand in his way.

What do you want to test? The scripts or the modules or both? 

We always need binaries and libraries to do the test, how do you expect me
to handle that? 

> > 4) when satisfied with the result, apply the rest of the patch
> > 5) Merge to trunk/
> 
> On second thought: as we don't apply the patch in trunk/, I will apply
> it completly and not in separate steps

Please find attached a patch rebased on the latest trunk (as requested on
IRC).

Cheers,
-- 
Raphaël Hertzog

Premier livre français sur Debian GNU/Linux :
http://www.ouaza.com/livre/admin-debian/
[dpkg-shlibdeps.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <team@dpkg.org>:
Bug#430367; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <team@dpkg.org>. Full text and rfc822 format available.

Message #25 received at 430367@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: Frank Lichtenheld <djpig@debian.org>
Cc: 430367@bugs.debian.org
Subject: Re: Bug#430367: Integrate support of a newer dpkg-shlibdeps working at the symbol level
Date: Sun, 1 Jul 2007 17:21:42 +0200
On Sun, 01 Jul 2007, Frank Lichtenheld wrote:
> I would give Raphael commit rights to the repository with the
> understanding that he limits himself to the branch integrating his work
> for now (I really see no need for technical measures enforcing that, we
> are all grown-ups, right?)

Sure, I have no problem with that.

Cheers,
-- 
Raphaël Hertzog

Premier livre français sur Debian GNU/Linux :
http://www.ouaza.com/livre/admin-debian/



Bug reassigned from package `dpkg' to `dpkg-dev'. Request was from Frank Lichtenheld <djpig@debian.org> to control@bugs.debian.org. (Mon, 02 Jul 2007 14:09:03 GMT) Full text and rfc822 format available.

Reply sent to Raphael Hertzog <hertzog@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Raphael Hertzog <hertzog@debian.org>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #32 received at 430367-close@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: 430367-close@bugs.debian.org
Subject: Bug#430367: fixed in dpkg 1.14.7~newshlib
Date: Tue, 25 Sep 2007 07:17:03 +0000
Source: dpkg
Source-Version: 1.14.7~newshlib

We believe that the bug you reported is fixed in the latest version of
dpkg, which is due to be installed in the Debian FTP archive:

dpkg-dev_1.14.7~newshlib_all.deb
  to pool/main/d/dpkg/dpkg-dev_1.14.7~newshlib_all.deb
dpkg_1.14.7~newshlib.dsc
  to pool/main/d/dpkg/dpkg_1.14.7~newshlib.dsc
dpkg_1.14.7~newshlib.tar.gz
  to pool/main/d/dpkg/dpkg_1.14.7~newshlib.tar.gz
dpkg_1.14.7~newshlib_i386.deb
  to pool/main/d/dpkg/dpkg_1.14.7~newshlib_i386.deb
dselect_1.14.7~newshlib_i386.deb
  to pool/main/d/dpkg/dselect_1.14.7~newshlib_i386.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 430367@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Raphael Hertzog <hertzog@debian.org> (supplier of updated dpkg package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Tue, 25 Sep 2007 08:43:45 +0200
Source: dpkg
Binary: dpkg dselect dpkg-dev
Architecture: source i386 all
Version: 1.14.7~newshlib
Distribution: experimental
Urgency: low
Maintainer: Dpkg Developers <team@dpkg.org>
Changed-By: Raphael Hertzog <hertzog@debian.org>
Description: 
 dpkg       - package maintenance system for Debian
 dpkg-dev   - package building tools for Debian
 dselect    - user tool to manage Debian packages
Closes: 10807 41907 48208 80340 109954 323911 395942 430367 431597 432893 437825 440502 440537 440636 440859 440956 440962 440972 440973 441051 441106 441113 443190 443191 443276
Changes: 
 dpkg (1.14.7~newshlib) experimental; urgency=low
 .
   [ Raphael Hertzog ]
   * dpkg-shlibdeps has been heavily reworked:
     * it supports "symbols" files to generate finer-grained
       dependencies. Closes: #430367
       Those files can be created by the new dpkg-gensymbols
       command.
     * it uses now all paths in RPATH (instead of only the first).
       Closes: #395942
     * it's now able to parse include directives in /etc/ld.so.conf.
       Closes: #431597
     * libraries are also searched in the public directories of packages
       being built and thus debian/shlibs.local can effectively define
       dependencies for libraries that are being built. Closes: #80340
     * "symbols" files use the full SONAME as key instead of splitting it in
       (name, version) like the "shlibs" format requires it. This allows
       binaries to be linked with unversioned libraries and not fail.
       Closes: #48208
       Note that unversioned libraries are still a very bad idea.
     * dpkg-shlibdeps now supports "-x<package>" options that can be used
       to exclude packages from generated dependencies. This is
       particalularly useful to avoid dependencies on ourselves when a
       package contains a binary and a library (without requiring an
       shlibs.local file to override the usual shlibs file). It might also
       be used to avoid other unwanted dependencies (use with care though).
       Closes: #41907, #109954
     * If dpkg-shlibdeps doesn't find any dependency information for a
       shared library that is actively used, then it will fail. This can be
       disabled with the option --ignore-missing-info. Closes: #10807
 .
   [ Guillem Jover ]
   * Add back $dpkglib into @INC, needed by the controllib.pl require in
     822-date. Closes: #440962
   * Document in dpkg-scanpackages that apt now requires Packages.bz2 in
     preference to Packages.gz. Closes: #440973
   * Stop recognizing the obsolete Optional field when building packages.
   * Use fakeroot, if present, by default to gain root privileges in
     dpkg-buildpackage.
   * Fix typos in dpkg-deb.1 and start-stop-daemon.8. Closes: #441051
     Thanks to A. Costa.
   * After '<prerm> remove' fails and while doing the error unwinding, if
     the '<postinst> abort-remove' call succeeds, preserve the old status
     instead of unconditionally setting it to 'Installed'. Closes: #432893
     Thanks to Brian M. Carlson.
   * Add Vcs-Browser and Vcs-Git fields to debian/control.
 .
   [ Frank Lichtenheld ]
   * Add _MTN to dpkg-source -i default regex. Suggested by Jari Aalto.
   * Convert dpkg-buildpackage to a Perl script.
   * dpkg-buildpackage accepts a -j<n> option now which will set
     MAKEFLAGS(-j<n>) and DEB_BUILD_OPTIONS(parallel=<n>) accordingly.
     parallel=<n> in DEB_BUILD_OPTIONS will be passed to MAKEFLAGS as
     well. Based on an idea by Robert Millan. Closes: #440636
   * Allow dpkg-source -I without a pattern which will load a default
     list of pattern similar to -i without regexp. Patch by
     Jari Aalto. Closes: #440972
   * Rework documentation of dpkg-source's -i and -I options.
     Closes: #323911, #440956
 .
   [ Updated dpkg translations ]
   * Basque (Piarres Beobide). Closes: #440859
   * Danish (Claus Hindsgaul). Closes: #441106
   * French (Frédéric Bothamy).
   * German (Sven Joachim). Closes: #440537
   * Nepali (Shiva Prasad Pokharel). Closes: #437825
   * Portuguese (Miguel Figueiredo). Closes: #441113
   * Romanian (Eddy Petri?or).
   * Vietnamese (Clytie Siddall). Closes: #440502
   * Korean (Sunjae Park). Closes: #443190
 .
   [ Updated man pages translations ]
   * German (Helge Kreutzmann).
   * Swedish (Peter Karlsson).
   * Korean (Sunjae Park). Closes: #443191
 .
   [ Updated scripts translations ]
   * Correct a typo in the French translation. Closes: #443276
Files: 
 0e724edaf152da5368df1936f424dc2e 969 admin required dpkg_1.14.7~newshlib.dsc
 1e4de4e5968f91365cc0d39034411b79 5939940 admin required dpkg_1.14.7~newshlib.tar.gz
 559bd1d755610c0eb14387bedad23a44 2089802 admin required dpkg_1.14.7~newshlib_i386.deb
 9a77429db7fcad1eacaf86f412174c78 508702 admin required dselect_1.14.7~newshlib_i386.deb
 434b8a6b1500244b69fc7d26548d70e6 240362 utils optional dpkg-dev_1.14.7~newshlib_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.6 (GNU/Linux)

iD8DBQFG+LItvPbGD26BadIRAt+JAJ9k6ZFVGPpzrc0c8syccbXL10N0vQCfZ2ro
+GVA5dgV1X1DgiFE2SuyLWI=
=1mdq
-----END PGP SIGNATURE-----





Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <team@dpkg.org>:
Bug#430367; Package dpkg-dev. Full text and rfc822 format available.

Acknowledgement sent to Frank Lichtenheld <djpig@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <team@dpkg.org>. Full text and rfc822 format available.

Message #37 received at 430367@bugs.debian.org (full text, mbox):

From: Frank Lichtenheld <djpig@debian.org>
To: control@bugs.debian.org
Cc: 109954@bugs.debian.org, 395942@bugs.debian.org, 41907@bugs.debian.org, 430367@bugs.debian.org
Subject: found 41907 in 1.14.1.6, found 395942 in 1.13.24, found 109954 in 1.19.17, found 430367 in 1.14.4
Date: Mon, 08 Oct 2007 14:37:43 +0200
# Automatically generated email from bts, devscripts version 2.10.9
# make the BTS display more sensible
found 41907 1.14.1.6
found 395942 1.13.24
found 109954 1.19.17
found 430367 1.14.4





Bug marked as found in version 1.14.4. Request was from Frank Lichtenheld <djpig@debian.org> to control@bugs.debian.org. (Mon, 08 Oct 2007 12:54:13 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Fri, 16 Nov 2007 07:30:09 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 11:15:35 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.